import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
* AWS EC2 Container Registry
*/
export interface DataAwsEcrpublicAuthorizationTokenConfig extends cdktf.TerraformMetaArguments {
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/aws/d/ecrpublic_authorization_token aws_ecrpublic_authorization_token}
*/
export declare class DataAwsEcrpublicAuthorizationToken extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "aws_ecrpublic_authorization_token";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/aws/d/ecrpublic_authorization_token aws_ecrpublic_authorization_token} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAwsEcrpublicAuthorizationTokenConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataAwsEcrpublicAuthorizationTokenConfig);
    get authorizationToken(): string;
    get expiresAt(): string;
    get id(): string;
    get password(): string;
    get userName(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
